local function findPlayerNode(p, node)
	for player in players.iterate do
		if #player == tonumber(node) and #p ~= #player then
			return(player)
		end
	end
	return
end
local function findPlayerName(p, name)
	for player in players.iterate do
		if player.name == name and #player ~= #p then
			return(player)
		end
	end
	return
end
local function partnerWithPlayer(player, findBy, playerToFind)
	local catchP = nil
	
	if string.lower(findBy) == 'name' then
		catchP = findPlayerName(player, playerToFind)
		if catchP == nil then
			CONS_Printf(player, [[Can't find player! Make sure the player isn't you.]])
			return
		end
	elseif string.lower(findBy) == 'node' then
		catchP = findPlayerNode(player, playerToFind)
		if catchP == nil then
			CONS_Printf(player, [[Can't find player! Make sure the player isn't you.]])
			return
		end
	else
		CONS_Printf(player, [[Can't find method! Please use either "name" or "node"]])
		return
	end

	if catchP ~= nil then
		if player.partner == catchP or catchP.partner == player then
			-- if you are partners
			player.partner = nil
			catchP.partner = nil
			player.partnerLead = nil
			catchP.partnerLead = nil
			CONS_Printf(player, 'No longer partners! You can request someone else.')
			CONS_Printf(catchP, 'No longer partners! You can request someone else.')
		elseif catchP.youRequested == player then
			-- if the person you requested is them, and they requested you
			if player.partner ~= nil then
				CONS_Printf(player.partner, 'No longer partners! You can request someone else.')
			end
			if catchP.partner ~= nil then
				CONS_Printf(catchP.partner, 'No longer partners! You can request someone else.')
			end
			player.partner = catchP
			catchP.partner = player
			player.youRequested = nil
			catchP.youRequested = nil
			player.partnerLead = player
			catchP.partnerLead = player
			CONS_Printf(player, [[You and ]]..catchP.name..[[ are now partners! You are the Leader]])
			CONS_Printf(catchP, [[You and ]]..player.name..[[ are now partners! They are the Leader]])
		elseif catchP.youRequested == nil and player.youRequested == nil then
			-- if the person you wanna request isnt requesting anyone else, and you arent requesting anyone
			player.youRequested = catchP
			CONS_Printf(player, [[Request sent to ]]..catchP.name)
			CONS_Printf(catchP, player.name..[[ requested you! Request them back to be their partner.]])
		end
	end
end
local function partnerConnection(player)
	if gametype ~= GT_COOP then
		return
	end

	if player.cmd.buttons & BT_ATTACK then
		player.firePressed = true
	else
		player.firePressed = false
		player.canPressFire = true
	end
	
	if player.partner == nil then
		return
	end

	if (P_IsObjectOnGround(player.mo) and player.canTele == false) then
		player.canTele = true
	end

	if player.partnerLead ~= player then
		return
	end

	if player.partner.rings ~= player.rings then
		player.partner.rings = player.rings
	end
	local dist = P_AproxDistance(player.mo.x - player.partner.mo.x, player.mo.y - player.partner.mo.y) / FRACUNIT
	if player.partner.canTele ~= false and player.partner.firePressed == true and player.partner.canPressFire == true then
		player.partner.canPressFire = false
		P_TeleportMove(player.partner.mo, player.mo.x, player.mo.y, (player.mo.z / FRACUNIT) + 1280 * FRACUNIT)
		if player.partner.charability ~= CA_FLY then
			player.partner.mo.state = S_PLAY_FALL
		else
			player.partner.mo.state = S_PLAY_FLY
			player.partner.pflags = $|PF_JUMPED|PF_THOKKED
			player.partner.powers[pw_tailsfly] = $+(20*TICRATE)
		end
		player.partner.mo.momx = player.mo.momx
		player.partner.mo.momy = player.mo.momy
		player.partner.mo.momz = 0
		player.partner.mo.angle = player.mo.angle
		player.partner.canTele = false
		P_ResetPlayer(player.partner)
		S_StartSound(player.mo, sfx_sktele)
	end
	if dist > 5000 then
		P_TeleportMove(player.partner.mo, player.mo.x, player.mo.y, (player.mo.z / FRACUNIT) + 1280 * FRACUNIT)
		if player.partner.charability ~= CA_FLY then
			player.partner.mo.state = S_PLAY_FALL
		else
			player.partner.mo.state = S_PLAY_FLY
			player.partner.pflags = $|PF_JUMPED|PF_THOKKED
			player.partner.powers[pw_tailsfly] = $+(20*TICRATE)
		end
		player.partner.mo.momx = player.mo.momx
		player.partner.mo.momy = player.mo.momy
		player.partner.mo.angle = player.mo.angle
		P_ResetPlayer(player.partner)
		S_StartSound(player.mo, sfx_sktele)
	end
end
local function disbandPartner(player)
	if player.partner == nil then
		return
	end
	player.partnerLead = nil
	player.partner.partnerLead = nil
	player.partner.partner = nil
	player.partner = nil
end

local function keepRingsIfPartnerNotLead(mobj, inflictor, source, damage, damagetype)
	local player = mobj.player
	if gametype ~= GT_COOP then
		return false
	end

	if player.partner ~= nil and player.partnerLead ~= player and source ~= player.partner then
		P_DoPlayerPain(player, source, inflictor)
		return true
	else
		return false
	end
end

addHook('PlayerThink', partnerConnection)
addHook('MobjDamage', keepRingsIfPartnerNotLead)
addHook('PlayerQuit', disbandPartner)

COM_AddCommand('partner', partnerWithPlayer)